<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_1/lang/en-US/guide/misc/races.php $
 * $Id: races.php 1365 2009-01-09 20:52:15Z quietust $
 */

if (!defined('IN_GUIDE'))
	die('Access denied');

guidepage($topic, 'races', 'g_races', 'Races');
function g_races ()
{
	global $era;
	global $races;
?>
<h2>Races</h2>
<p>There are many different races in the world, each with their own distinct advantages and disadvantages in the following areas:</p>
<dl>
    <dt>Offense</dt>
        <dd>Your offensive power while attacking other empires.</dd>
    <dt>Defense</dt>
        <dd>Your defensive power when being attacked by other empires.</dd>
    <dt>Building</dt>
        <dd>How quickly you can construct (and demolish) structures.</dd>
    <dt>Upkeep</dt>
        <dd>The amount of money you must pay for upkeep on your military units.</dd>
    <dt>Magic</dt>
        <dd>Your magical power, used when casting spells and when other empires cast spells on you.</dd>
    <dt>Industry</dt>
        <dd>Your ability to produce military units.</dd>
    <dt>Economy</dt>
        <dd>Your Per Capita Income, how much money your citizens make each turn.</dd>
    <dt>Exploration</dt>
        <dd>How much land you gain per turn spent exploring.</dd>
    <dt>Market</dt>
        <dd>The prices of military units on the private market.</dd>
    <dt>Consumption</dt>
        <dd>The amount of <?=lang($era->food)?> your population and military consumes each turn.</dd>
    <dt>Energy</dt>
        <dd>The rate at which your <?=lang($era->trpwiz)?> produce <?=lang($era->runes)?>.</dd>
    <dt>Agriculture</dt>
        <dd>The rate at which your <?=lang($era->bldfood)?> produce <?=lang($era->food)?>.</dd>
</dl>
<table border="1">
<tr><th>Race</th>
    <th>Offense</th>
    <th>Defense</th>
    <th>Building</th>
    <th>Upkeep</th>
    <th>Magic</th>
    <th>Industry</th>
    <th>Economy</th>
    <th>Exploration</th>
    <th>Market</th>
    <th>Consumption</th>
    <th>Energy</th>
    <th>Agriculture</th></tr>
<?
	$attribs = array('offense' => 1, 'defense' => 1, 'buildrate' => 1, 'expenses' => 2, 'magic' => 1, 'industry' => 1, 'income' => 1, 'explore' => 1, 'market' => 2, 'foodcon' => 2, 'runepro' => 1, 'foodpro' => 1);
	foreach ($races as $rid => $rname)
	{
		$race = new prom_race($rid);
?>
<tr><th><?=$race?></th>
<?
		foreach ($attribs as $attrib => $type)
		{
?>
    <td><?
			$val = 100 * ($race->getData($attrib) - 1);
			if ($type == 1)
				echo colornum($val, percent(abs($val)), 'cgood', 'cbad', 'cneutral', '+', '-', '+');
			if ($type == 2)
				echo colornum($val, percent(abs($val)), 'cbad', 'cgood', 'cneutral', '+', '-', '-');
?></td>
<?
		}
?></tr>
<?
	}
?>
</table>
<?
}
?>
