<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_1/pages/admin/market.php $
 * $Id: market.php 1442 2009-02-18 21:08:09Z quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'ADMIN_MARKET_TITLE';

$needpriv = UFLAG_ADMIN;

require(PROM_BASEDIR .'includes/header.php');

$defcost = array(MARKET_TRPARM => PVTM_TRPARM, MARKET_TRPLND => PVTM_TRPLND, MARKET_TRPFLY => PVTM_TRPFLY, MARKET_TRPSEA => PVTM_TRPSEA, MARKET_FOOD => PVTM_FOOD);
$types = array(MARKET_TRPARM => 'trparm', MARKET_TRPLND => 'trplnd', MARKET_TRPFLY => 'trpfly', MARKET_TRPSEA => 'trpsea', MARKET_FOOD => 'food');

$doreturn = fixInputBool(getFormVar('return'));
$checked = array();
if ($action == 'remove') do
{
	$list = getFormArr('remove');
	$remove = '';
	foreach ($list as $num)
	{
		if (strlen($remove))
			$remove .= ',';
		$remove .= fixInputNum($num);
		$checked[$num] = TRUE;
	}
	if (!strlen($remove))
	{
		notice(lang('ADMIN_MARKET_ERROR_NOTHING'));
		break;
	}
	// lock all checked market items
	$q = $db->prepare('UPDATE '. MARKET_TABLE .' SET lock_id = ? WHERE lock_id = 0 AND k_id IN ('. $remove .')');
	db_bindIntValue($q, 1, $user1->u_id);
	$q->execute();

	// fetch a list of everything that was locked
	$q = $db->prepare('SELECT * FROM '. MARKET_TABLE .' WHERE lock_id = ?');
	db_bindIntValue($q, 1, $user1->u_id);
	$q->execute();
	$markets = $q->fetchAll();
	// then handle returns for each one, if necessary
	$removed = 0;
	foreach ($markets as $market)
	{
		if ($doreturn)
		{
			$emp_b = prom_empire::cached_load($market['e_id']);
			$basecost = $defcost[$market['k_type']];
			$lost = floor($market['k_amt'] * (min(max($market['k_price'] - $basecost, 0) / $basecost, 0.3) + 0.2));
			addEmpireNews(EMPNEWS_ATTACH_MARKET_RETURN, NULL, $emp_b, $market['k_type'], $market['k_amt'], $market['k_price'], $market['k_amt'] - $lost);
			$emp_b = NULL;
		}
		unset($checked[$market['k_id']]);
		$removed++;
	}

	// finally, delete the lot of them
	$q = $db->prepare('DELETE FROM '. MARKET_TABLE .' WHERE lock_id = ?');
	db_bindIntValue($q, 1, $user1->u_id);
	$q->execute();

	notice(lang('ADMIN_MARKET_COMPLETE', $removed));
	if (count($checked) > 0)
		notice(lang('ADMIN_MARKET_REMAINING', count($checked)));
	logevent();
} while (0);
notices();

$sortcol = getFormVar('sortcol', 'uid');
$sortdir = getFormVar('sortdir', 'asc');
if ($sortdir == 'asc')
	$dir = ' ASC';
else	$dir = ' DESC';
switch ($sortcol)
{
	default:
		$sortcol = 'eid';
	case 'eid':
		$sortby = 'e_id';
		break;
	case 'type':
		$sortby = 'k_type';
		break;
	case 'amt':
		$sortby = 'k_amt';
		break;
	case 'price':
		$sortby = 'k_price';
		break;
	case 'time':
		$sortby = 'k_time';
		break;
}
$total = sqleval($db, 'SELECT COUNT(*) FROM '. MARKET_TABLE);
$page = fixInputNum(getFormVar('page'));
$per = 50;	// 50 rows per page
$offset = ($page - 1) * $per;
if ($offset > $total)
{
	$page = ceil($total / $per);
	$offset = ($page - 1) * $per;
}
if ($offset < 0)
{
	$page = 1;
	$offset = 0;
}
$sortlink = '?location=admin/market&amp;';
?>
<form method="post" action="?location=admin/market">
<table>
<tr><th><?=sortlink(lang('COLUMN_ADMIN_EMPIREID'), $sortlink, $sortcol, $sortdir, 'eid', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_MARKET_COLUMN_TYPE'), $sortlink, $sortcol, $sortdir, 'type', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_MARKET_COLUMN_AMT'), $sortlink, $sortcol, $sortdir, 'amt', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_MARKET_COLUMN_PRICE'), $sortlink, $sortcol, $sortdir, 'price', 'asc', $page)?></th>
    <th><?=sortlink(lang('ADMIN_MARKET_COLUMN_TIME'), $sortlink, $sortcol, $sortdir, 'time', 'asc', $page)?></th>
    <th><?=lang('ADMIN_MARKET_COLUMN_REMOVE')?></th></tr>
<?
$sql = 'SELECT * FROM '. MARKET_TABLE .' ORDER BY '. $sortby . $dir;
$sql = db_setLimit($db, $sql, $per, $offset);
$q = $db->query($sql) or warning('Failed to fetch market item list', 0);
$markets = $q->fetchAll();
foreach ($markets as $market)
{
	$time = CUR_TIME - $market['k_time'];
?>
<tr><td class="ar"><?=prenum($market['e_id'])?></td>
    <td><?=lang($emp1->era->getData($types[$market['k_type']]))?></td>
    <td class="ac"><?=number($market['k_amt'])?></td>
    <td class="ac"><?=money($market['k_price'])?></td>
    <td class="ar"><?=colornum($time, gmdate('z:H:i:s', abs($time)), 'cgood', 'cwarn', 'cgood', '+', '-', '+')?></td>
    <td class="ar"><?=checkbox('remove[]', '', $market['k_id'], isset($checked[$market['k_id']]))?></td></tr>
<?
}
$pages = ceil($total / $per);
if ($pages > 0)
	echo '<tr><td colspan="7" class="ar">'. pagelist($page, $pages, $sortlink, $sortcol, $sortdir) .'</td></tr>';
?>
<tr><td colspan="6" class="ar">
        <input type="hidden" name="action" value="remove" />
        <input type="hidden" name="sortcol" value="<?=$sortcol?>" /><input type="hidden" name="sortdir" value="<?=$sortdir?>" /><input type="hidden" name="page" value="<?=$page?>" />
        <?=checkbox('return', lang('ADMIN_MARKET_RETURN'), 1, $doreturn)?><br />
        <input type="submit" value="<?=lang('ADMIN_MARKET_SUBMIT')?>" /></td></tr>
</table>
</form>
<?
require(PROM_BASEDIR .'includes/footer.php');
?>
