<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_1/pages/banner.php $
 * $Id: banner.php 1361 2009-01-02 21:58:34Z quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

function giveBonusTurns ()
{
	global $db, $lock;

	if (!ROUND_STARTED)
		return 0;	// don't give turns if the game isn't running

	// header.php isn't used here, so we have to do all of this manually

	if ((!isset($_COOKIE['prom_user'])) || (!isset($_COOKIE['prom_empire'])) || (!isset($_COOKIE['prom_session'])))
		return 0; // no cookies

	$user1 = new prom_user($_COOKIE['prom_user']);
	if (!$user1->load())
		return 0; // no user

	if ($user1->u_session != md5($_COOKIE['prom_session']))
		return 0; // no session

	$emp1 = new prom_empire($_COOKIE['prom_empire']);
	if (!$emp1->load())
		return 0;	// no empire

	if ($emp1->u_id == 0)
		return 0;	// deleted empire

	if (($emp1->u_id != $user1->u_id) && (!($user1->u_flags & UFLAG_ADMIN)))
		return 0;	// bad empire

	if ($emp1->e_freeturns >= CUR_TIME)
		return 0;	// already got free turns

	$turnbonus = ceil(60 / TURNS_FREQ) * TURNS_COUNT;

	// update $lock for logging purposes
	$lock['emp1'] = $emp1->e_id;
	prom_entity::lock_entities(array($emp1), $user1->u_id);

	$emp1->e_freeturns = CUR_TIME + 86400;
	$emp1->e_turns += $turnbonus;
	if ($emp1->e_turns > TURNS_MAXIMUM)
	{
		$emp1->e_storedturns += $emp1->e_turns - TURNS_MAXIMUM;
		$emp1->e_turns = TURNS_MAXIMUM;
		if ($emp1->e_storedturns > TURNS_STORED)
			$emp1->e_storedturns = TURNS_STORED;
	}
	$emp1->save();	// give 1 hour worth of turns and reset timer
	return $turnbonus;
}

$dest = 'game';	// In the event of failure, jump back to this page
if ($action == 'click')
{
	$id = fixInputNum(getFormVar('banner_id'));
	if (isset($banners[$id]))
	{
		if (BONUS_TURNS)
			$turns = giveBonusTurns();
		$url = $banners[$id]['url'];
		if ($banners[$id]['ismap'])
		{
			$click_x = fixInputNum(getFormVar('banner_img_x'));
			$click_y = fixInputNum(getFormVar('banner_img_y'));
			$url .= '?'. $click_x .','. $click_y;
		}
		logevent(varlist(array('turns', 'id'), get_defined_vars()));
		redirect($url);
	}
}
elseif ($action == 'bonus')
{
	if (count($banners) == 0)
	{
		if (BONUS_TURNS)
			$turns = giveBonusTurns();
		logevent(varlist(array('turns'), get_defined_vars()));
		$dest = getFormVar('bonus_return', 'game');
	}
}
redirect(URL_BASE .'?location='. urlencode($dest));
?>
