<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_1/pages/topplayers.php $
 * $Id: topplayers.php 1456 2009-02-23 17:53:22Z quietust $
 */

if (!defined('IN_GAME'))
	die('Access denied');

$sortcol = getFormVar('sortcol', 'avgrank');
$sortdir = getFormVar('sortdir', 'desc');
if ($sortdir == 'asc')
	$dir = 'ASC';
else	$dir = 'DESC';
switch ($sortcol)
{
	default:
		$sortcol = 'avgrank';
	case 'avgrank':
		$sortby = 'u_avgrank '. $dir .', u_id ASC';
		break;
	case 'bestrank':
		$sortby = 'u_bestrank '. $dir .', u_id ASC';
		break;
	case 'offtotal':
		$sortby = 'u_offtotal '. $dir .', u_id ASC';
		break;
	case 'deftotal':
		$sortby = 'u_deftotal '. $dir .', u_id ASC';
		break;
	case 'kills':
		$sortby = 'u_kills '. $dir .', u_id ASC';
		break;
	case 'deaths':
		$sortby = 'u_deaths '. $dir .', u_id ASC';
		break;
	case 'plays':
		$sortby = 'u_numplays '. $dir .', u_id ASC';
		break;
}

$numplayers = sqleval($db, 'SELECT COUNT(*) FROM '. USER_TABLE);
$disabled = sqleval($db, 'SELECT COUNT(*) FROM '. USER_TABLE .' WHERE u_flags & ? != 0', array(UFLAG_DISABLE));
$closed = sqleval($db, 'SELECT COUNT(*) FROM '. USER_TABLE .' WHERE u_flags & ? != 0', array(UFLAG_CLOSED));

$playing = array();
$q = $db->query('SELECT u_id,u_oldid FROM '. EMPIRE_TABLE);
foreach ($q as $data)
{
	if ($data['u_id'] > 0)
		$playing[$data['u_id']] = TRUE;
	if ($data['u_oldid'] > 0)
		$playing[$data['u_oldid']] = TRUE;
}

$html = new prom_html_compact();
$html->begin('TOPPLAYERS_TITLE');
?>
<h2><?=lang('TOPPLAYERS_HEADER')?></h2>
<?=gmdate('r', CUR_TIME)?><br /><br />
<?=lang('TOPPLAYERS_CREATED')?> <span class="cgood"><?=$numplayers?></span><br />
<?=lang('TOPPLAYERS_DISABLED')?> <span class="mdisabled"><?=$disabled?></span><br />
<?=lang('TOPPLAYERS_CLOSED')?> <span class="mdead"><?=$closed?></span><br /><br />
<?=lang('COMMON_COLORKEY')?> <span class="mprotected"><?=lang('COMMON_COLOR_NEW')?></span> - <span class="mdisabled"><?=lang('COMMON_COLOR_DISABLED')?></span> - <span class="mdead"><?=lang('COMMON_COLOR_CLOSED')?></span> - <span class="madmin"><?=lang('COMMON_COLOR_ADMIN')?></span><br />
<?=lang('TOPPLAYERS_NOTE_PLAYING')?><br />
<table class="scorestable">
<tr class="era0">
    <th class="ar"><?=sortlink(lang('COLUMN_AVGRANK'), '?location=topplayers&amp;', $sortcol, $sortdir, 'avgrank', 'desc')?></th>
    <th class="ac"><?=lang('COLUMN_USER')?></th>
    <th class="ar"><?=sortlink(lang('COLUMN_ROUNDSPLAYED'), '?location=topplayers&amp;', $sortcol, $sortdir, 'plays', 'desc')?></th>
    <th class="ar"><?=sortlink(lang('COLUMN_BESTRANK'), '?location=topplayers&amp;', $sortcol, $sortdir, 'bestrank', 'desc')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_ATTACKS'), '?location=topplayers&amp;', $sortcol, $sortdir, 'offtotal', 'desc')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_DEFENDS'), '?location=topplayers&amp;', $sortcol, $sortdir, 'deftotal', 'desc')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_KILLS'), '?location=topplayers&amp;', $sortcol, $sortdir, 'kills', 'desc')?></th>
    <th class="ac"><?=sortlink(lang('COLUMN_DEATHS'), '?location=topplayers&amp;', $sortcol, $sortdir, 'deaths', 'desc')?></th></tr>
<?

$sql = 'SELECT u_avgrank,u_name,u_id,u_flags,u_numplays,u_bestrank,u_offsucc,u_offtotal,u_defsucc,u_deftotal,u_kills,u_deaths FROM '. USER_TABLE .' ORDER BY '. $sortby;
$sql = db_setLimit($db, $sql, TOPPLAYERS_COUNT);
$topplayers = $db->query($sql) or warning('Failed to fetch top players listing', 0);
while ($data = $topplayers->fetch())
{
	$user_a = new prom_user($data['u_id']);
	$user_a->initdata($data);

	$color = 'normal';
	if ($user_a->u_flags & UFLAG_MOD)
		$color = 'admin';
	elseif ($user_a->u_flags & UFLAG_CLOSED)
		$color = 'dead';
	elseif ($user_a->u_flags & UFLAG_DISABLE)
		$color = 'disabled';
	elseif ($user_a->u_numplays == 0)
		$color = 'protected';
?>
<tr class="m<?=$color?>">
    <td class="ar"><?if (isset($playing[$user_a->u_id])) echo "*";?><?=percent($user_a->u_avgrank * 100, 2)?></td>
    <td class="ac"><a href="?location=playerstats&amp;id=<?=$user_a->u_id?>"><?=$user_a?></a></td>
    <td class="ar"><?=number($user_a->u_numplays)?></td>
    <td class="ar"><?=percent($user_a->u_bestrank * 100, 2)?></td>
    <td class="ac"><?=$user_a->u_offtotal?> (<?=percent($user_a->u_offsucc / max($user_a->u_offtotal, 1) * 100)?>)</td>
    <td class="ac"><?=$user_a->u_deftotal?> (<?=percent($user_a->u_defsucc / max($user_a->u_deftotal, 1) * 100)?>)</td>
    <td class="ac"><?=$user_a->u_kills?></td>
    <td class="ac"><?=$user_a->u_deaths?></td></tr>
<?
	$user_a = NULL;
}
// footer row shouldn't have sort links on it
?>
<tr class="era0">
    <th class="ar"><?=lang('COLUMN_AVGRANK')?></th>
    <th class="ac"><?=lang('COLUMN_USER')?></th>
    <th class="ar"><?=lang('COLUMN_ROUNDSPLAYED')?></th>
    <th class="ar"><?=lang('COLUMN_BESTRANK')?></th>
    <th class="ac"><?=lang('COLUMN_ATTACKS')?></th>
    <th class="ac"><?=lang('COLUMN_DEFENDS')?></th>
    <th class="ac"><?=lang('COLUMN_KILLS')?></th>
    <th class="ac"><?=lang('COLUMN_DEATHS')?></th></tr>
</table>
<?
$html->end();
?>
